c "KVR- SeeSchStrO-Ausweichregeln"
c COPYRIGHT: This program is subject to the GNU General Public License
c     (GPL), version 3 or any later version.
      kvrsss=0
      call init(ka1,ka2,ka3,ks,kb1,kb2,kb3,kvr,kafw,kbfw,khnfw,
     &          kueb,kent,keng,kvtg,kavt,kbvt,kluv)
c.................................
  1   write(*,*)
      do 2 i=1,50
        write(*,*)
  2   continue
      write(*,*)'                                           [v_4]'
      write(*,*)'             Ausweichregeln  '
      write(*,*)'       fuer Segel- oder Motor-Schiffe '
      write(*,*)
      write(*,*)'             im Bereich der '
      write(*,*)
      write(*,*)'******************************************************'
      write(*,*)'     FAHRWASSER & SEESCHIFFFAHRTSSTRASSEN, '
      write(*,*)'     ( => SeeSchifffahrtsStrassenOrdnung )'
      write(*,*)'******************************************************'
      write(*,*)
      write(*,*)'            sowie im Bereich der '
      write(*,*)
      write(*,*)'######################################################'
      write(*,*)'                HOHEN SEE '
      write(*,*)'     ( => Kollisionsverhuetungsregeln, KVR )'
      write(*,*)'######################################################'
      write(*,*)
      write(*,*)
      write(*,*)'                                      <[enter]...> '
      read(*,*)
      call spaces()
cc      if(0.eq.0) goto 2001
      write(*,*)'-----------------------------------------------------'
      write(*,*)'Info:  Prinzip der Situationsanalyse:'
      write(*,*)
      write(*,*)'1) Ident A, B (A=Segel/Motor-Schiff, B=beliebig)'
      write(*,*)'2) SeeSchifffahrtsStrassenOrdnung:'
      write(*,*)'      (KVR#9); #23, #24, #25(2,4,5)'
      write(*,*)'3) KVR:'
      write(*,*)'      KVR#9,10,19,13,12,18,14,15'
      write(*,*)
      write(*,*)'(Begegnungen z.B. von 2 Fischern werden analog'
      write(*,*)'zur Begegnung von 2 Motor-Schiffen behandelt).'
      write(*,*)'-----------------------------------------------------'
      write(*,*)'NOTE:  No guarantee whatsoever, handle with care !!!'
      write(*,*)
      write(*,*) '    <...Hit RETURN to continue>'
      read(*,*)
 2001 continue
      indkvr=1
      call spaces()
c Schiffstypen
      call n1eig(ka1,ka2)
      call n3geg(kb1,kb2)
c KVR oder SSSO
      call n4kvr(kvr)
      if(kvr.eq.1) goto 505
      if(kvr.eq.2) goto 506
      if(0.eq.0) goto 888
 505  continue
c seeschifffahrtsstrassenordnung
      write(*,*) '... also gilt die SeeSchifffahrtsStrassenOrdnung.'
      if(kb1.eq.6) then
      write(*,*)'Der Tiefgangbehinderte zeigt sich als Wegerechtschiff,'
      endif
      if(kb1.eq.4 .or. kb1.eq.6) then
      write(*,*)'B gilt als manoevrierbehindert (Lichter:R-W-R).'
      write(*,*)
      write(*,*)'#2 SeeSchStrO  u.  KVR-Regel #18:'
      write(*,*) '  A darf das Wegerechtschiff nicht behindern!'
      write(*,*) '(Wir gehen davon aus, dass B im Hauptfahrwasser ist).'
      goto 888
      endif
      write(*,*)
      write(*,*)
      write(*,*)
      write(*,*)
      call n5afw(kafw)
      call n5bfw(kbfw)
      call n5hnfw(kafw,kbfw,khnfw)

c Entscheidungen:
      if(khnfw.gt.1) goto 5052

c 25(3) segler nach KVR, oder dem FW deutlich folgend
      if(ka1.eq.2 .and. kb1.eq.2) then
         if(kafw.le.3 .and. kbfw.le.3) then
      write(*,*) '*************** SeeSchStrO **************************'
      write(*,*) '# 25(3): '
      write(*,*) '... also 2 Segler, ausweichen nach KVR ....wie folgt'
      write(*,*) '*****************************************************'
           goto 5059
         endif
         if(kafw.eq.4 .and. kbfw.le.3) then
      write(*,*) '****************** SeeSchStrO ***********************'
           call vorf(1)
           goto 888
         endif
         if(kbfw.eq.4 .and. kafw.le.3) then
      write(*,*) '****************** SeeSchStrO ***********************'
           call vorf(2)
           goto 888
         endif
      endif

c 25(4) haupt-nebenfw
 5052 continue
      if(khnfw.gt.1) then
      write(*,*) '****************** SeeSchStrO ***********************'
      write(*,*) '# 25(4):'
      if(khnfw.eq.2) call vorf(2)
      if(khnfw.eq.3) call vorf(1)
      goto 888
      endif

c $21 allg., nicht dem FW folgend, Hinweis auf KVR
      if(kafw.le.2 .and. kbfw.le.2) then
      write(*,*) '*************** SeeSchStrO **************************'
      write(*,*) '# 21:'
        write(*,*) '... nicht dem FW folgend, Ausweichen nach KVR'
      write(*,*) '*****************************************************'
        goto 5059
      endif

c $25(2) den FW folgende haben Vorfahrt
      if(kafw.ge.3 .and. kbfw.le.2) then
      write(*,*) '****************** SeeSchStrO ***********************'
      write(*,*) '# 25(2):'
      call vorf(1)
      goto 888
      endif
      if(kbfw.ge.3 .and. kafw.le.2) then
      write(*,*) '****************** SeeSchStrO ***********************'
      write(*,*) '# 25(2):'
      call vorf(2)
      goto 888
      endif
      
c Abfrage: Ueberholer, Engstelle

      call n0ueb(kueb)
      call n5ent(kueb,kent)
      call n5eng(kent,keng)

c Entscheidungen:

c 23 und $25(5) dem FW folgend, entweder ueberholend oder entgegen
      if(kafw.ge.3 .and. kbfw.ge.3) then
c ueberholer
       if(kueb.gt.1) then
      write(*,*) '****************** SeeSchStrO ***********************'
      write(*,*) '# 23:'
       if(kueb.eq.2) call vorf(2)
       if(kueb.eq.3) call vorf(1)
       goto 888
       endif
c entgegen
       if(kent.eq.2) then
       if(ka1.eq.2 .and. kb1.eq.2) then
          if(ka3.eq.kb3 .and. ka3.lt.3) then
          write(*,*) '... das duerfte eine Patenthalse geben!'
          write(*,*)
          endif
       endif
       if(keng.gt.1) then
      write(*,*) '****************** SeeSchStrO ***********************'
        write(*,*) '# 25(5):'
        if(keng.eq.2) call vorf(1)
        if(keng.eq.3) call vorf(2)
        goto 888
       endif
       endif
      endif

c allg, 21:
      write(*,*) '****************** SeeSchStrO ***********************'
      write(*,*) '# 21 und 22:'
      write(*,*) 'A und B halten scharf rechts, KVR#9'
      if(kb1.eq.3) then
      write(*,*)'(B als Fischer darf anderes Fzg im FW nicht behindern)'
      endif
      if((ka1.eq.1 .and.ka2.eq.1) .or. ka1.eq.2) then
       write(*,*) '(A darf dabei ein grosses Fahrzeug nicht behindern)'
      endif
      if((kb1.eq.1 .and.kb2.eq.1) .or. kb1.eq.2) then
       write(*,*) '(B darf dabei ein grosses Fahrzeug nicht behindern)'
      endif
      write(*,*) '*****************************************************'
      if(0.eq.0) goto 888
 5059 continue
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c................................Beginn KVR.........................
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      indkvr=2
      call sokvr(kafw,kbfw,kvtg)
c
 506  continue
      write(*,*)
      write(*,*)
c check: freies Wasser, Fahrwasser oder VTG
      if(indkvr.eq.1) then
      call vtg(kvtg)
      endif
      
c #9 Fahrwasser, bei jeder Sicht
      if(kvtg.eq.2) then
      if(indkvr.eq.1) then
       call n6afw(kafw)
       call n6bfw(kbfw)
      endif
      write(*,*) '-----------------------------------------------------'
      write(*,*) 'Regel 9 - (Rechtsfahrgebot im engen Fahrwasser)'

c    Nichtbehinderungsgebot fuer Kleinfahrzeuge
      kleina=1
      kleinb=1
      if(ka1.eq.2 .or. (ka1.eq.1 .and. ka2.lt.2)) kleina=2
      if(kb1.eq.2 .or. (kb1.eq.1 .and. kb2.lt.2)) kleinb=2

c    Beide sind im Fahrwasser
      if(kafw.ge.2 .and. kbfw.ge.2) then

      if(kb1.eq.3) then
      write(*,*) 'Fischendes Fzg. B darf A nicht behindern.'
      goto 5061
      endif

      if(kleina.eq.2  .and. kb1.ne.2 .and .kbfw.eq.3) then
      if(kleinb.ne.2) write(*,*) 'A darf B nicht behindern.'
      goto 5061
      endif

      if(kleinb.eq.2  .and. ka1.ne.2 .and. kafw.eq.3) then
      if(kleina.ne.2) write(*,*) 'B darf A nicht behindern.'
      goto 5061
      endif

      if(kleina.eq.1  .and. kleinb.eq.1) then
      write(*,*) 'A und B weichen untereinander nach KVR aus.'
      goto 5061
      endif

      endif

c    Queren (2) des Einbahnweges checken
      if(kafw.le.2 .and. kbfw.eq.3) then
      write(*,*) 'A darf beim Queren des FW B nicht behindern.'
      goto 5061
      endif
      if(kbfw.le.2 .and. kafw.eq.3) then
      write(*,*) 'B darf beim Queren des FW A nicht behindern.'
      goto 5061
      endif
      if(kbfw.le.2 .and. kafw.le.2) then
      write(*,*) 'A und B weichen untereinander nach KVR aus.'
      goto 5061
      endif

 5061 continue
      write(*,*) 'Das Behinderungsverbot im FW soll Ausweichsituationen'
      write(*,*) 'vermeiden! (KVR-Ausweichregeln 12-19 bleiben gueltig)'
      write(*,*) '-----------------------------------------------------'
      write(*,*)
      endif
c
c
c #10 Verkehrstrennungsgebiet, bei allen Sichtverhaeltnissen
      if(kvtg.eq.3) then
      call n6avt(kavt)
      call n6bvt(kbvt)
      write(*,*)'------------------------------------------------------'
      write(*,*) 'Regel 10 - VTG: (Einbahnrichtung ist einzuhalten)'
      
c    Nichtbehinderungsgebot fuer Kleinfahrzeuge und Segler
      kleina=1
      kleinb=1
      if(ka1.eq.2 .or. (ka1.eq.1 .and. ka2.lt.2)) kleina=2
      if(kb1.eq.2 .or. (kb1.eq.1 .and. kb2.lt.2)) kleinb=2

c    Beide folgen dem Einbahnweg
      if(kavt.eq.3 .and. kbvt.eq.3) then
      if(kb1.eq.3 .and. kavt.eq.3) then
      write(*,*) 'Fischendes Fzg. B darf A nicht behindern.'
      goto 5062
      endif

      if(kleina.eq.2  .and. kb1.ne.2 .and .kbvt.eq.3) then
      write(*,*) 'A darf B nicht behindern.'
      goto 5062
      endif

      if(kleinb.eq.2  .and. ka1.ne.2 .and. kavt.eq.3) then
      write(*,*) 'B darf A nicht behindern.'
      goto 5062
      endif

      if(kleina.eq.1  .and. kleinb.eq.1) then
      write(*,*) 'A und B weichen untereinander nach KVR aus.'
      goto 5062
      endif

      endif

 5062 continue
c    Queren (2) des Einbahnweges checken
      if(kavt.le.2 .and. kbvt.eq.3) then
      write(*,*) 'A muss Queren vermeiden, um B nicht zu behindern.'
      goto 5063
      endif
      if(kbvt.le.2 .and. kavt.eq.3) then
      write(*,*) 'B muss Queren vermeiden, um A nicht zu behindern.'
      goto 5063
      endif
      if(kbvt.le.2 .and. kavt.le.2) then
      write(*,*) 'A und B weichen untereinander nach KVR aus.'
      goto 5063
      endif
      
 5063 continue
      write(*,*)'Das Behinderungsverbot im VTG soll Ausweichsituationen'
      write(*,*)'vermeiden! (KVR-Ausweichregeln 12-19 bleiben gueltig)'
      write(*,*)'------------------------------------------------------'
      write(*,*)
      endif

c Sichtverhaeltnisse
      call n2sic(ks)


c #19 Nebel
      if(ks.eq.2) then
      write(*,*) '#####################################################'
      write(*,*) 'Verminderte Sicht,'
      write(*,*) '(die ganze Zeit mit sicherer Geschwindigkeit fahren!)'
      write(*,*) 'Regel 19: Jeder muss jedem ausweichen'
      write(*,*) '#####################################################'
      write(*,*)
      call regel19
      goto 888
      endif

cc      write(*,*) '... die Sicht ist also nicht vermindert'
      write(*,*)
      
c #13 Ueberholer
      call n0ueb(kueb)
      if(kueb.ne.1) then
       if(kueb.eq.2) then
      write(*,*) '#####################################################'
      write(*,*) 'Regel 13: A muss als Ueberholer ausweichen'
      write(*,*) '#####################################################'
       else
      write(*,*) '#####################################################'
      write(*,*) 'Regel 13: B muss als Ueberholer ausweichen'
      write(*,*) '#####################################################'
       endif
       goto 888
      endif

c #12 Segler unter sich   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      if(ka1.eq.2 .and. kb1.eq.2) then
c      write(*,*) '... es sind also zwei Segler'
      jausw=0
      write(*,*)
      call awind(ka1,ka3)
      call bwind(kb1,kb3)
      
c klare Segelstellungen
      if(ka3.lt.3 .and. kb3.lt.3) then
      if(kb3.ne.ka3) then
      write(*,*) '#####################################################'
      if(ka3.eq.1) write(*,*) 'Regel 12a(i): A ist ausweichpflichtig'
      if(ka3.eq.2) write(*,*) 'Regel 12a(i): B ist ausweichpflichtig'
      if(ka3.eq.1) jausw=1
      if(ka3.eq.2) jausw=2
      call fwspec(indkvr,jausw,ka1,kb1,kafw,kbfw)
      write(*,*) '#####################################################'
      goto 888
      endif

      call n6luv(kluv)

      if(kb3.eq.ka3) then
      write(*,*) '#####################################################'
      if(kluv.eq.1) write(*,*) 'Regel 12a(ii): A ist ausweichpflichtig'
      if(kluv.eq.2) write(*,*) 'Regel 12a(ii): B ist ausweichpflichtig'
      if(kluv.eq.1) jausw=1
      if(kluv.eq.2) jausw=2
      call fwspec(indkvr,jausw,ka1,kb1,kafw,kbfw)
      write(*,*) '#####################################################'
      goto 888
      endif
      endif
      
c unklare Segelstellung, B
      call n6luv(kluv)

      if(kb3.ge.3) then
      write(*,*)'A kann die Segelstellung auf B nicht klar erkennen,'
      write(*,*)'umgekehrt muss das Gleiche angenommen werden'
      write(*,*)
      if(ka3.eq.1 .and.kluv.eq.2) then
      write(*,*) '#####################################################'
      write(*,*) 'Regel 12a(iii): A ist ausweichpflichtig'
      jausw=1
      call fwspec(indkvr,jausw,ka1,kb1,kafw,kbfw)
      write(*,*) '#####################################################'
      goto 888
      endif
      if(ka3.eq.1 .and.kluv.eq.1) then
      write(*,*) '#####################################################'
      write(*,*) 'Regel 12a(i,ii): A ist ausweichpflichtig'
      jausw=1
      call fwspec(indkvr,jausw,ka1,kb1,kafw,kbfw)
      write(*,*) '#####################################################'
      goto 888
      endif
      if(ka3.eq.2 .and.kluv.eq.2) then
      write(*,*) '#####################################################'
      write(*,*) 'Regel 12a(i,ii): B ist ausweichpflichtig'
      jausw=2
      call fwspec(indkvr,jausw,ka1,kb1,kafw,kbfw)
      write(*,*) '#####################################################'
      goto 888
      endif
      if(ka3.eq.2 .and.kluv.eq.1) then
      write(*,*) '#####################################################'
      write(*,*) 'Wenn B anscheinend nicht ausweicht, muss A im Zweifel'
      write(*,*) 'nach Regel 2(a) damit rechnen, dass B in LEE liegend'
      write(*,*) 'Wind auch von StB hat.'
      write(*,*) 'Dann gilt Regel 12a(ii)):   A ist ausweichpflichtig'
      jausw=1
      call fwspec(indkvr,jausw,ka1,kb1,kafw,kbfw)
      write(*,*) '#####################################################'
      goto 888
      endif
      endif
      endif
c
c #18 Fahrzeuge untereinander
      if(ka1.ne.kb1) then
      write(*,*) '#####################################################'
      write(*,*) 'Regel 18 - Fahrzeuge untereinander:'
      if(kb1.eq.6) then
      write(*,*)'A darf das tiefgangbehinderte Fzg. nicht behindern,'
      write(*,*)'muss also versuchen, den Weg freizumachen (KVR#8fii).'
      if(ka1.ne.1) then
      write(*,*) 'A ist also NICHT Kurshalter.   Aber: '
      write(*,*) 'Wenn jetzt Nahbereichslage eingetreten ist, muss'
      write(*,*) 'das tiefgangbehinderte Maschinenfahrzeug B trotz'
      write(*,*) 'der Tiefgangbehinderung versuchen, dem Fahrzeug A'
      write(*,*) 'auszuweichen, bzw. aufzustoppen (KVR#8fiii).'
      write(*,*) '#####################################################'
      goto 888
      endif
      endif
      if(ka1.lt.kb1) write(*,*) 'A ist ausweichpflichtig'
      if(ka1.gt.kb1) write(*,*) 'B ist ausweichpflichtig'
      write(*,*) '#####################################################'
      goto 888
      endif

c #14 Masch Fzg., Entgegengesetzte Kurse
c #15 Masch Fzg., Kreuzende Kurse
      if(ka1.eq.kb1 .and. ka1.ne.2) then
      write(*,*) '#####################################################'
      write(*,*) '                  Maschinenfahrzeuge:'
      write(*,*) 'Regel 14 - Entgegengesetzte Kurse:'
      write(*,*) 'Beide weichen nach Steuerbord aus.'
      write(*,*) 'Regel 15 - Kreuzende Kurse:'
      write(*,*) 'Wer den Anderen an Steuerbord sieht, muss ausweichen'
      write(*,*) '(Nicht vor dem Bug des anderen Schiffs kreuzen).'
      write(*,*) '#####################################################'
      goto 888
      endif

c *******************************************************
      call leer()
      read(*,*)
      if(0.eq.0) goto 1
 888  continue
      write(*,*)
      write(*,*)
      write(*,*) '            <=== ENDE der ANALYSE ===>'
      write(*,*)
      write(*,*) '                                       [enter]....'
      read(*,*)
      if(0.eq.0) goto 1
 999  continue
      write(*,*) '~~~~~~~~~~~~~~~~~~~END of Program~~~~~~~~~~~~~~~~~~~~'
      write(*,*)
      write(*,*)
      read(*,*)
      stop
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine leer()
      write(*,*)
      write(*,*) '??????????? Keine Ausweichregel getroffen ????????'
      write(*,*) 'Dies ist ein Programmfehler. Bitte nochmals'
      write(*,*) 'durchlaufen lassen, und alle Parameter notieren!'
      write(*,*) '(Der Autor dankt fuer Rueckmeldung).'
      write(*,*)
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine spaces()
      do 1 i=1,30
        write(*,*)
 1    continue
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine pausx
      write(*,*)
      write(*,*)
      write(*,*) '                       hit [enter] to continue...'
      read(*,*)
      read(*,*)
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine n1eig(ka1,ka2)
c Schiffs-ID:  Eigenes
      write(*,*) 'Typ des  Schiffes   A ?'
      write(*,*)
      write(*,*) '     1=Motorschiff,     2=Segler [0=stop]'
      call readc(2,ka1)
      if(ka1.eq.1) then
      write(*,*) 'Laenge des  Schiffes A ?                '
      write(*,*)
      write(*,*) '   1= kleiner 20m , 2= groesser 20m '
      call readc(2,ka2)
      endif
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine awind(ka1,ka3)
c Wind A
      if(ka1.ne.2) return
  20  continue
      write(*,*) 'Wind, von welcher Seite fuer eigenes Schiff A ?'
      write(*,*)
      write(*,*) '1=von BB'
      write(*,*) '2=von StB'
      call readc(2,ka3)
      if(ka3.gt.2) goto 20
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine bwind(kb1,kb3)
c Wind B
      if(kb1.ne.2) return
  20  continue
      write(*,*) 'Wind, von welcher Seite fuer gegner. Schiff B ?'
      write(*,*)
      write(*,*) '1=von BB,  3= BB,  aber vom A nicht erkennbar!'
      write(*,*) '2=von StB, 4= StB, aber vom A nicht erkennbar!'
      call readc(4,kb3)
      if(kb3.gt.4) goto 20
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine n2sic(ks)
c Sichtverhaeltnisse
      write(*,*) 'Sichtverhaeltnisse ?'
      write(*,*)
      write(*,*) '   1= klare Sicht;  2= Nebel, verminderte Sicht'
      call readc(2,ks)
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine n3geg(kb1,kb2)
c Schiffs-ID:
      write(*,*) 'Typ des Gegners B ?'
      write(*,*)
      write(*,*) ' 1=Maschine,    2=Segler '
      write(*,*) ' 3=fischend,    4=manoevr.behind.   5=manoev.unf. '
      write(*,*) ' 6=tiefgangbehindert'
      write(*,*)
      write(*,*) '(Bei Nebel egal ob 2,3,4,5 oder 6!) '
      call readc(6,kb1)
      if(kb1.eq.1) then
      write(*,*) 'Laenge des Schiff B?                '
      write(*,*)
      write(*,*) '   1= kleiner 20m , 2= groesser 20m,  [0=stop])'
      call readc(2,kb2)
      endif
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine n4kvr(kvr)
c Seegebiet
      write(*,*) 'Welches Seegebiet?'
      write(*,*)
      write(*,*) '1=SeeSchifffahrtsStrassen       2=Hohe See (KVR)'
      write(*,*) '     (KVR=Kollosionsverhuetungsregeln) '
      call readc(2,kvr)
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine n5afw(kafw)
c Fahrwasser A
      write(*,*) 'Wie liegt A relativ zum Fahrwasser?'
      write(*,*)
      write(*,*) '  1=nicht im FW, 2=im FW, aber nicht folgend'
      write(*,*) '  3=im FW, etwa folgend, 4=im FW, deutlich folgend'
      call readc(4,kafw)
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine n5bfw(kbfw)
c Fahrwasser B
      write(*,*) 'Wie liegt B relativ zum Fahrwasser?'
      write(*,*)
      write(*,*) '  1=nicht im FW, 2=im FW, aber nicht folgend'
      write(*,*) '  3=im FW, etwa folgend, 4=im FW, deutlich folgend'
      call readc(4,kbfw)
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine fwspec(indkvr,jausw,ka1,kb1,kafw,kbfw)
c Spezielle Situation: 2 Segler, einer im FW ("3"), einer ausserhalb
c jausw=1,2 heisst: A,B ist ausweichpflichtig als Segler
      if(indkvr.ne.2) return
      if(ka1.ne.2 .or.kb1.ne.2) return
      if(kafw.eq.3 .and.  kbfw.eq.1) goto 100
      if(kafw.eq.1 .and.  kbfw.eq.3) goto 200
cc      write(*,*) '###end fwspec'
      return
 100  continue
      if(jausw.ne.1) return
      write(*,*)
      write(*,*)'(Aber: A folgt immerhin grob dem FW, B ist ausserhalb,'
      write(*,*)'B sollte kein Vorfahrtsrecht durchzusetzen versuchen!)'
      return
 200  continue
      if(jausw.ne.2) return
      write(*,*)
      write(*,*)'(Aber: B folgt immerhin grob dem FW, A ist ausserhalb,'
      write(*,*)'A sollte kein Vorfahrtsrecht durchzusetzen versuchen!)'
      return
      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine sokvr(kafw,kbfw,kvtg)
c Fahrwasser B
      kvtg=1
      if(kafw.ge.2 .and. kbfw.ge.2) then
      kvtg=2
      write(*,*) '... beide Schiffe im Fahrwasser.'
      write(*,*)
      endif
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine n5hnfw(kafw,kbfw,khnfw)
c Haupt-Nebenfahrwasser
      if(kafw.le.1 .or. kbfw.le.1) then
      khnfw=1
      return
      endif
      write(*,*) 'Gibt es Haupt- und Nebenfahrwasser?'
      write(*,*)
      write(*,*) '  1=es gibt nur 1 Fahrwasser '
      write(*,*) '  2=B im Haupt-, A im Nebenfahrwasser'
      write(*,*) '  3=A im Haupt-, B im Nebenfahrwasser'
      call readc(3,khnfw)
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine n0ueb(kueb)
c Ueberholer
      write(*,*) 'Ist einer der beiden A oder B ein Ueberholer ?'
      write(*,*)
      write(*,*) '  1=Nein'
      write(*,*) '  2=A ueberholt B'
      write(*,*) '  3=B ueberholt A'
      call readc(3,kueb)
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine n5ent(kueb,kent)
c Entgegen
      if(kueb.gt.1) then
      kent=1
      return
      endif
      write(*,*) 'Fahren A und B entgegengesetzte Kurse? '
      write(*,*)
      write(*,*) '  1=Nein   2=JA'
      call readc(2,kent)
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine n5eng(kent,keng)
c Engstelle
      if(kent.eq.1) return
      write(*,*) 'Gibt es beim Begegnen eine Engstelle ?'
      write(*,*)
      write(*,*) '  1=Nein'
      write(*,*) '  2=A faehrt mit (zukuenftiger) Stroemung'
      write(*,*) '     (bzw. haelt die Steuerbord-FW-Seite an)'
      write(*,*) '  3=B faehrt mit (zukuenftiger) Stroemung'
      write(*,*) '     (bzw. haelt die Steuerbord-FW-Seite an)'
      call readc(3,keng)
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine vorf(j)
c Vorfahrt
      if(j.eq.1) then
      write(*,*) 'A hat Vorfahrt, B ist ausweich- bzw. wartepflichtig'
       else
      write(*,*) 'B hat Vorfahrt, A ist ausweich- bzw. wartepflichtig'
      endif
      write(*,*) '*****************************************************'
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine n6afw(kafw)
c Fahrwasser A
      write(*,*) 'Wie liegt A relativ zum Fahrwasser?'
      write(*,*)
      write(*,*) '  1=nicht im FW, 2=im FW, aber nicht folgend'
      write(*,*) '  3=im FW, folgend'
      call readc(3,kafw)
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine n6bfw(kbfw)
c Fahrwasser B
      write(*,*) 'Wie liegt B relativ zum Fahrwasser?'
      write(*,*)
      write(*,*) '  1=nicht im FW, 2=im FW, aber nicht folgend'
      write(*,*) '  3=im FW, folgend'
      call readc(3,kbfw)
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine vtg(kvtg)
      write(*,*) 'Welche Fahrwassersituation liegt vor?'
      write(*,*)
      write(*,*) '  1=freier Seeraum, 2=Fahrwasser, '
      write(*,*) '  3=Verkehrstrennungsgebiet (VTG)'
      write(*,*)
      write(*,*) '(Es gelten jetzt die Regeln nach KVR)'
      call readc(3,kvtg)
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine n6avt(kavt)
c Verkehrstrennungsgebiet A
      write(*,*) 'Wie liegt A relativ zum Einbahnweg?'
      write(*,*)
      write(*,*) '  1=nicht im VTG, 2=querend,'
      write(*,*) '  3=im Einbahnweg, folgend'
      call readc(3,kavt)
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine n6bvt(kbvt)
c Verkehrstrennungsgebiet B
      write(*,*) 'Wie liegt B relativ zum Einbahnweg?'
      write(*,*)
      write(*,*) '  1=nicht im VTG, 2=querend,'
      write(*,*) '  3=im Einbahnweg, folgend'
      call readc(3,kbvt)
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine kursh(ks,j)
c Ausweichen
      if(ks.ne.2) then
      write(*,*) '####################KVR##############################'
      if(j.eq.1) then
      write(*,*) 'B ist ausweichpflichtig, A ist Kurshalter'
       else
      write(*,*) 'A ist ausweichpflichtig, B ist Kurshalter'
      endif
      write(*,*) '#####################################################'
      else
      write(*,*) '####################KVR##############################'
      if(j.eq.1) then
      write(*,*) 'B darf nicht behindern'
       else
      write(*,*) 'A darf nicht behindern'
      endif
      write(*,*) 'Aber beachte: Verminderte Sicht,'
      write(*,*) 'Regel 19: Jeder muss jedem ausweichen'
      write(*,*) '#####################################################'
      endif
      write(*,*)
      read(*,*)
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine kursvt(ks,j)
c Vorfahrt
      if(ks.ne.2) then
      write(*,*) '################### vtg #############################'
      if(j.eq.1) then
      write(*,*) 'B ist ausweichpflichtig, A ist Kurshalter'
       else
      write(*,*) 'A ist ausweichpflichtig, B ist Kurshalter'
      endif
      write(*,*) '#####################################################'
      else
      write(*,*) '################### vtg #############################'
      if(j.eq.1) then
      write(*,*) 'B darf nicht behindern'
       else
      write(*,*) 'A darf nicht behindern'
      endif
      write(*,*) 'Aber beachte: Verminderte Sicht,'
      write(*,*) 'Regel 19: Jeder muss jedem ausweichen'
      write(*,*) '#####################################################'
      endif
      write(*,*)
      read(*,*)
      return
      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine n6luv(kluv)
c Luv-Lee Regel fuer Segler
      write(*,*) 'Wie liegt A zu B relativ zum Wind?'
      write(*,*)
      write(*,*) '  1= A ist in LUV (von B)'
      write(*,*) '  2= A ist in LEE (von B)'
      call readc(2,kluv)
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine regel19
      DATA j0,jr/2*1/
      write(*,*)
      write(*,*) 'Wollen Sie Zusatzinformationen zu Regel 19 KVR?'
      write(*,*)
      write(*,*) '   1=nein,    2=ja'
      write(*,*)
      call readc(2,j0)
      if(j0.eq.1) return
c
      write(*,*) 'Fahren Sie nur mit HOERWACHE, oder unter RADAR ?'
      write(*,*)
      write(*,*) '                 1=HOERWACHE,          2=RADAR'
      write(*,*)
      call readc(2,jr)
      if(jr.lt.2) goto 100
      goto 200
c Hoerwache
 100  continue
      write(*,*) 'Von wo aus hoeren Sie das Nebelsignal ? '
      write(*,*)
      write(*,*) '#####################################################'
      write(*,*) ' vorlicher als querab      =  STOP !!!'
      write(*,*) ' (Kursaenderung erst bei SICHT des Gegners !)'
      write(*,*)
      write(*,*) ' achterlicher als querab:      Kursaenderung:   '
      write(*,*) '               BB  achtern =     45 grd StB      -->'
      write(*,*) '               StB achtern =  45 grd BB      <-- '
      write(*,*) '#####################################################'
      write(*,*)
      goto 999
c Radar
 200  continue
      write(*,*) 'Von wo aus sehen Sie den Gegner kommen ? '
      write(*,*)
      write(*,*) '#####################################################'
      write(*,*) '      aus Richtung     Ausweichen nach'
      write(*,*) '            12 Uhr =      90 grd StB       --->'
      write(*,*) '            01 Uhr =      90 grd StB       --->'
      write(*,*) '            02 Uhr =      -- Aufstoppen   0  '
      write(*,*) '            03 Uhr =   60 grd BB       <--'
      write(*,*) '            04 Uhr =   60 grd BB       <--'
      write(*,*) '            05 Uhr =   30 grd BB        <-'
      write(*,*) '            06 Uhr =      30 grd StB       ->'
      write(*,*) '            07 Uhr =      30 grd StB       ->'
      write(*,*) '            08 Uhr =      60 grd StB       -->'
      write(*,*) '            09 Uhr =      60 grd StB       -->'
      write(*,*) '            10 Uhr =      60 grd StB       -->'
      write(*,*) '            11 Uhr =      90 grd StB       --->'
      write(*,*) '#####################################################'
      write(*,*)
      goto 999
 999  continue
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine readit(xxx)
      character*8 aaa,bbb
      bbb=' '
      aaa='abcdefgh'
      write(6,901) xxx
      read(5,'(a)') aaa
      write(*,*) aaa
      if(aaa.eq.bbb) goto 999
      read(aaa,*) xxx
      if(xxx.gt.  999999.) xxx= 999999.
      if(xxx.lt. -999999.) xxx=-999999.
 999  continue
      do 10 i=1,50
      write(*,*)
  10  continue
      return
 901  format('        [ Default: ',f6.1,' ]    Input=')
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine readc(kmax,kkk)
      character*8 aaa,bbb
      kres=kkk
  1   continue
      bbb=' '
      aaa='abcdefgh'
      write(*,*)
      write(*,*)'====================================================='
      write(6,901) kkk
      read(5,'(a)') aaa
c      write(*,*) aaa
      if(aaa.eq.bbb) goto 999
      read(aaa,*) kkk
      if(kkk.le.0) then
       write(*,*) '#################### Ende des Programms ############'
       stop
      endif
      if(kkk.eq.200444)then
       write(*,*) '<autor: h.mueller-krumbhaar>'
       read(*,*)
      kkk=0
      endif
      if(kkk.gt.kmax) then
        write(*,*) 'falsche Eingabe :',kkk
        kkk=kres
        goto 1
      endif
c
 999  continue
      do 10 i=1,50
      write(*,*)
  10  continue
      return
 901  format('        [Default: ',i3,']    Input=')
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine init(ka1,ka2,ka3,ks,kb1,kb2,kb3,kvr,kafw,kbfw,khnfw,
     &                kueb,kent,keng,kvtg,kavt,kbvt,kluv)
c Initiale Kennzeichnung der Situation (siehe unten):
      ka1=2
      ka2=1
      ka3=2
      ks=1
      kb1=2
      kb2=1
      kb3=3
      kvr=2
      kafw=3
      kbfw=3
      khnfw=1
      kueb=1
      kent=1
      keng=1
      kvtg=1
      kavt=2
      kbvt=3
      kluv=1
c-----------------------------------------------------------
c      ka1=2  Schiffstyp A
c      ka2=1  Laenge A
c      ka3=2  Wind A
c      ks=1   Sicht 1=klar 2=unsichtig
c      kb1=6  Schiffstyp B
c      kb2=1  Laenge B
c      kb3=1  Wind B
c      kvr=2  1=SSSO   2=KVR
c      kafw=3  A zum FW: 1=nicht 2=folgend
c      kbfw=3  B zum FW: ...
c      khnfw=1  Haupt/NebenFW: 1=- 2=B-H,A-N  3=A-H,B-N
c      kueb=1  Ueberholer 1=- 2=A 3=B
c      kent=1  Entgegenkommen 1=- 2=JA
c      keng=1  Engstelle 1=- 2=JA
c      kvtg=3  1=freie See   2=FW   3=VTG
c      kavt=2  A im VTG  1=- 2=querend 3=folgend
c      kbvt=3  B im VTG  1=- 2=querend 3=folgend
c      kluv=1  1=A in Luv    2=B in LUV
c-----------------------------------------------------------
      return
      end
cccccccccc ENDE ccccccccccccccccccccccccccccccccccccccccccccccc

